/**
 * generated by Xtext 2.15.0
 */
package fr.irisa.cairn.graphviz.model.ui.labeling;

import com.google.common.collect.Iterables;
import com.google.inject.Inject;
import fr.irisa.cairn.graphviz.model.dotty.LabelAttribute;
import fr.irisa.cairn.graphviz.model.dotty.LeafNode;
import fr.irisa.cairn.graphviz.model.dotty.SubNode;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

/**
 * Provides labels for EObjects.
 * 
 * See https://www.eclipse.org/Xtext/documentation/304_ide_concepts.html#label-provider
 */
@SuppressWarnings("all")
public class DottyLabelProvider extends DefaultEObjectLabelProvider {
  @Inject
  public DottyLabelProvider(final AdapterFactoryLabelProvider delegate) {
    super(delegate);
  }
  
  public String text(final LeafNode n) {
    String _xblockexpression = null;
    {
      final Iterable<LabelAttribute> labels = Iterables.<LabelAttribute>filter(n.getAttributes(), LabelAttribute.class);
      String _xifexpression = null;
      LabelAttribute _head = IterableExtensions.<LabelAttribute>head(labels);
      boolean _tripleNotEquals = (_head != null);
      if (_tripleNotEquals) {
        String _name = n.getName();
        String _plus = ("node " + _name);
        String _plus_1 = (_plus + "[");
        String _label = IterableExtensions.<LabelAttribute>head(labels).getLabel();
        String _plus_2 = (_plus_1 + _label);
        _xifexpression = (_plus_2 + "]");
      } else {
        String _name_1 = n.getName();
        _xifexpression = ("node " + _name_1);
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
  
  public String text(final SubNode n) {
    String _xblockexpression = null;
    {
      final Iterable<LabelAttribute> labels = Iterables.<LabelAttribute>filter(n.getBody().getAttributes(), LabelAttribute.class);
      String _xifexpression = null;
      LabelAttribute _head = IterableExtensions.<LabelAttribute>head(labels);
      boolean _tripleNotEquals = (_head != null);
      if (_tripleNotEquals) {
        String _name = n.getName();
        String _plus = ("subgraph" + _name);
        String _plus_1 = (_plus + "[");
        String _label = IterableExtensions.<LabelAttribute>head(labels).getLabel();
        String _plus_2 = (_plus_1 + _label);
        _xifexpression = (_plus_2 + "]");
      } else {
        String _name_1 = n.getName();
        _xifexpression = ("subgraph" + _name_1);
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
}
